library(tidyverse)
library(raster)
date="2-15-2021"
run=3
V= "G" # Do you want to use the good and marginal EVI observations (GM) or just the good (G)
data.grouped2=read.table("/home/wh350/climate_variability/evi_sddata2-15-20213.grouped.postmodern.txt")

spatial.weights = function(data.x, data.y){
myco=cbind(data.x, data.y)
s=sp::SpatialPoints(myco,proj4string = crs("+proj=longlat +ellps=clrk66 +no_defs"))
myco.knn=spdep::knearneigh(s,k=24,longlat = T)
myco.nb=spdep::knn2nb(myco.knn)
myco.l2=spdep::nb2listw(myco.nb)
return(myco.l2)
}

spatial.weights=spatial.weights(data.x = data.grouped2$x,
                                data.y = data.grouped2$y)

lm.past = lm(std.resid ~ scale(poly(temp_sd.1950, 2)) + scale(poly(vpd_sd.1950, 
    2)) + scale(real_change.temp) + scale(poly(temp_sd.1950, 
    2)):scale(real_change.temp),data=data.grouped2)
print(summary(lm.past))

sp.error.past <- spatialreg::errorsarlm(std.resid ~ scale(poly(temp_sd.1950, 2)) + scale(poly(vpd_sd.1950, 
    2)) + scale(real_change.temp) + scale(poly(temp_sd.1950, 
    2)):scale(real_change.temp), data=data.grouped2, spatial.weights)
print(summary(sp.error.past))


sp.lag.past <- spatialreg::lagsarlm(std.resid ~ scale(poly(temp_sd.1950, 2)) + scale(poly(vpd_sd.1950, 
    2)) + scale(real_change.temp) + scale(poly(temp_sd.1950, 
    2)):scale(real_change.temp),data=data.grouped2, spatial.weights)

print(summary(sp.lag.past))
print(spdep::moran.mc(resid(lm.past), spatial.weights, nsim=999, zero.policy=TRUE))
print(spdep::moran.mc(resid(sp.lag.past), spatial.weights, nsim=999, zero.policy=TRUE))
print(spdep::moran.mc(resid(sp.error.past), spatial.weights, nsim=999, zero.policy=TRUE))

print("Finished past analysis")